INCLUDE REG_52.PDF 

RB0     EQU     000H    ; Select Register Bank 0
RB1     EQU     008H    ; Select Register Bank 1  ...poke to PSW to use

DIS_A	EQU	P0.2		
DIS_B	EQU	P0.3		
DIS_C	EQU	P0.4
DIS_D	EQU	P0.6
DIS_E	EQU	P0.5
DIS_F	EQU	P0.1
DIS_G	EQU	P0.0

DIS1	EQU	P0.7
DIS2	EQU	P2.7                
DIS3	EQU	P2.6
DIS4	EQU	P2.5

KEYYS	EQU	P3

ROW11	EQU	P3.0
ROW12	EQU	P3.1
ROW13	EQU	P3.2
ROW14	EQU	P3.3
COL11	EQU	P3.4
COL12	EQU	P3.5
COL13	EQU	P3.6
COL14	EQU	P3.7

LED1	EQU	P2.0
VOTE_L	EQU	P2.1
PASS_L	EQU	P2.2
READY_L	EQU	P2.3

ALRM	EQU	P2.4

DISPLAY	EQU	P3.0
COUNTING	EQU	P3.1
CLEAR		EQU	P3.3

WMCON   DATA    96h 		; watchdog and memory control register
EEMEN   EQU     00001000b 	; EEPROM access enable bit
EEMWE   EQU     00010000b 	; EEPROM write enable bit
WDTRST  EQU     00000010b 	; EEPROM RDY/BSY bit
DPS     EQU     00000100b 	; data pointer select bit

DSEG            ; This is internal data memory
ORG     20H     ; Bit adressable memory
FLAGS:	DS	1
FLAG	BIT	FLAGS.0
KEYY:	DS	1
N1:	DS	1
N2:	DS	1
N3:	DS	1
N4:	DS	1

COUNT:	DS	1
SPEED:	DS	1
VALUE_1:	DS	1
VALUE_2:	DS	1
VALUE_3:	DS	1
VALUE_4:	DS	1

CAN11:	DS	1
CAN12:	DS	1
CAN21:	DS	1
CAN22:	DS	1
CAN31:	DS	1
CAN32:	DS	1
CAN41:	DS	1
CAN42:	DS	1
CAN51:	DS	1
CAN52:	DS	1
CAN61:	DS	1
CAN62:	DS	1
CAN71:	DS	1
CAN72:	DS	1
CAN81:	DS	1
CAN82:	DS	1
CAN91:	DS	1
CAN92:	DS	1
CANA1:	DS	1
CANA2:	DS	1
CANB1:	DS	1
CANB2:	DS	1
CANC1:	DS	1
CANC2:	DS	1
CAND1:	DS	1
CAND2:	DS	1
CANE1:	DS	1
CANE2:	DS	1
CANF1:	DS	1
CANF2:	DS	1
CANG1:	DS	1
CANG2:	DS	1



STACK:	DS		1
CSEG     AT      0        ; RESET VECTOR
;---------==========----------==========---------=========---------
;              PROCESSOR INTERRUPT AND RESET VECTORS
;---------==========----------==========---------=========---------
 
	ORG     00H    		; Reset
	JMP     MAIN

	ORG 	000BH		;Timer Interrupt0
	JMP 	REFRESH
;---------==========----------==========---------=========---------	
MAIN:	
	MOV PSW,#RB0      	; Select register bank 0
   MOV SP,STACK
	CLR FLAG
	SETB READY_L
	SETB PASS_L
	SETB LED1
	SETB VOTE_L
	CLR ALRM
	CALL RESET_VOTE
	
	MOV SPEED,#00H
	MOV COUNT,#00H	
	MOV VALUE_1,#15H
	MOV VALUE_2,#15H
	MOV VALUE_3,#15H
	MOV VALUE_4,#15H
	CLR DIS1
	CLR DIS2
	CLR DIS3
	CLR DIS4
	MOV TMOD,#01H		;enable timer0 for scanning
	MOV TL0,#00H
	MOV TH0,#0FDH
	SETB ET0
	SETB EA
	SETB TR0		;Start the Timer
	
KEYBOARD:
		CPL VOTE_L
		
		MOV KEYY,#00H	
		SETB COL11
		SETB COL12
		SETB COL13
		SETB COL14
K1A:	CLR ROW11
		CLR ROW12
		CLR ROW13
		CLR ROW14
		MOV A,KEYYS
		ORL A,#11111111B
		ANL A,#11110000B
		CJNE A,#11110000B,K1A		;check till all KEYYs released
K2A:	CALL DEALAY            		;call 20 msec delay
		MOV A,KEYYS			;see if any KEYY is pressed
		ANL A,#11110000B			;mask unused bits
		CJNE A,#11110000B,OVER_1		;KEYY pressed, await closure
		SJMP K2A
OVER_1:	
		CALL DEALAY
		MOV A,KEYYS
		ANL A,#11110000B
		CJNE A,#11110000B,OVER_2
		SJMP K2A
OVER_2:	
		MOV A,KEYYS
		ORL A,#11111111B
		MOV KEYYS,A
		CLR ROW11
		MOV A,KEYYS
		ANL A,#11110000B
		CJNE A,#11110000B,ROW_A
		MOV A,KEYYS
		ORL A,#11111111B
		MOV KEYYS,A
		CLR ROW12
		MOV A,KEYYS
		ANL A,#11110000B
		CJNE A,#11110000B,ROW_B
		MOV A,KEYYS
		ORL A,#11111111B
		MOV KEYYS,A
		CLR ROW13
		MOV A,KEYYS
		ANL A,#11110000B
		CJNE A,#11110000B,ROW_C
		MOV A,KEYYS
		ORL A,#11111111B
		MOV KEYYS,A
		CLR ROW14
		MOV A,KEYYS
		ANL A,#11110000B
		CJNE A,#11110000B,ROW_D
		AJMP K2A


ROW_A:	
	RLC A
	JC MAT12
	MOV KEYY,#01H
	AJMP K9
MAT12:	RLC A
	JC MAT22
	MOV KEYY,#02H
	AJMP K9
MAT22:	RLC A
	JC MAT23
	MOV KEYY,#03H
	AJMP K9
MAT23:	RLC A
	JC K9
	MOV KEYY,#04H
	AJMP K9
	
ROW_B:	RLC A
	JC MAT32
	MOV KEYY,#05H
	AJMP K9
MAT32:	RLC A
	JC MAT42
	MOV KEYY,#06H
	AJMP K9
MAT42:	RLC A
	JC MAT43
	MOV KEYY,#07H
	AJMP K9
MAT43:	RLC A
	JC K9
	MOV KEYY,#08H
	AJMP K9
	
ROW_C:	RLC A
	JC MAT52
	MOV KEYY,#09H
	AJMP K9
MAT52:	RLC A
	JC MAT62
	MOV KEYY,#10H
	AJMP K9
MAT62:	RLC A
	JC MAT63
	MOV KEYY,#11H
	AJMP K9
MAT63:	RLC A
	JC K9
	MOV KEYY,#12H
	AJMP K9
	
ROW_D:	RLC A
	JC MAT72
	MOV KEYY,#13H
	AJMP K9
MAT72:	RLC A
	JC MAT82	
	MOV KEYY,#14H			;for 0
	AJMP K9
MAT82:	RLC A
	JC MAT83
	MOV KEYY,#15H
	AJMP K9
MAT83:	RLC A
	JC K9
	MOV KEYY,#16H
	MOV R3,#01H
K9:
		
		CLR VOTE_L
		CALL DELAY
		SETB VOTE_L
		
		JB FLAG,UPP3			;Jump if vote is entered
		
		CJNE R3,#01H,G1
		INC R3
		MOV N1,KEYY
		AJMP KEYBOARD
G1:	CJNE R3,#02H,G2
		INC R3
		MOV N2,KEYY
		AJMP KEYBOARD
G2:	CJNE R3,#03H,G3
		INC R3
		MOV N3,KEYY
		AJMP KEYBOARD
G3:	CJNE R3,#04H,G4
		MOV R3,#01H
		MOV N4,KEYY
G4:	
		
	
		MOV A,N1
		SWAP A
		ORL A,N2
		MOV N2,A				;HIGHER DIGITSS IN N2
		MOV A,N3
		SWAP A
		ORL A,N4
		MOV N4,A				;LOWER DISITS IN N4
		
		MOV A,N2
		CJNE A,#14H, BV2	;Password	1434
		MOV A,N4
		CJNE A,#34H,BV2
		CLR PASS_L
		SETB ALRM
		CALL DELAY
		CLR ALRM
		CALL DELAY
		SETB PASS_L
		CLR READY_L		
		SETB FLAG
							;ROUTINE FOR Password ok	
BV2:	AJMP KEYBOARD
		
UPP3:	SETB READY_L
		SETB ALRM
		MOV A,KEYY
		CJNE A,#01H,FGF1
		MOV R6,CAN11
		MOV R7,CAN12
		CALL INCREMENT
		MOV CAN11,R6
		MOV CAN12,R7
		ORL  WMCON, #EEMEN		 ; enable EEPROM accesses			STORE CANDIDATE 1 VOTES
		ORL WMCON, #EEMWE		 ; enable EEPROM writes
		MOV DPTR, #0000H			 ; address to write
		MOV A, CAN11			 ; data to write
		MOVX @DPTR,A			 ; write EEPROM
		MOV A,WMCON			;Check for eeprom finished or not
		JNB ACC.1,$-2		 ; jump if data compare fails (busy)
		INC DPTR
		MOV A, CAN12			 ; data to write
		MOVX @DPTR,A			 ; write EEPROM
		MOV A,WMCON			;Check for eeprom finished or not
		JNB ACC.1,$-2		 ; jump if data compare fails (busy)
		XRL WMCON, #EEMWE		 ; disable EEPROM writes
		XRL WMCON, #EEMEN		 ; disable EEPROM accesses
		CALL DELAY
		CLR ALRM
		CLR READY_L
		AJMP DOWN_D
		
FGF1:	CJNE A,#02H,FGF2
		MOV R6,CAN21
		MOV R7,CAN22
		CALL INCREMENT
		MOV CAN21,R6
		MOV CAN22,R7
		ORL  WMCON, #EEMEN		 ; enable EEPROM accesses			STORE CANDIDATE 2 VOTES
		ORL WMCON, #EEMWE		 ; enable EEPROM writes
		MOV DPTR, #0002H			 ; address to write
		MOV A, CAN21			 ; data to write
		MOVX @DPTR,A			 ; write EEPROM
		MOV A,WMCON			;Check for eeprom finished or not
		JNB ACC.1,$-2		 ; jump if data compare fails (busy)
		INC DPTR
		MOV A, CAN22			 ; data to write
		MOVX @DPTR,A			 ; write EEPROM
		MOV A,WMCON			;Check for eeprom finished or not
		JNB ACC.1,$-2		 ; jump if data compare fails (busy)
		XRL WMCON, #EEMWE		 ; disable EEPROM writes
		XRL WMCON, #EEMEN		 ; disable EEPROM accesses
		CALL DELAY
		CLR ALRM
		CLR READY_L
		AJMP DOWN_D		
		
FGF2:	CJNE A,#03H,FGF3
		MOV R6,CAN31
		MOV R7,CAN32
		CALL INCREMENT
		MOV CAN31,R6
		MOV CAN32,R7
		ORL  WMCON, #EEMEN		 ; enable EEPROM accesses			STORE CANDIDATE 2 VOTES
		ORL WMCON, #EEMWE		 ; enable EEPROM writes
		MOV DPTR, #0004H			 ; address to write
		MOV A, CAN31			 ; data to write
		MOVX @DPTR,A			 ; write EEPROM
		MOV A,WMCON			;Check for eeprom finished or not
		JNB ACC.1,$-2		 ; jump if data compare fails (busy)
		INC DPTR
		MOV A, CAN32			 ; data to write
		MOVX @DPTR,A			 ; write EEPROM
		MOV A,WMCON			;Check for eeprom finished or not
		JNB ACC.1,$-2		 ; jump if data compare fails (busy)
		XRL WMCON, #EEMWE		 ; disable EEPROM writes
		XRL WMCON, #EEMEN		 ; disable EEPROM accesses
		CALL DELAY
		CLR ALRM
		CLR READY_L
		AJMP DOWN_D	
			
FGF3:	CJNE A,#04H,FGF4
		MOV R6,CAN41
		MOV R7,CAN42
		CALL INCREMENT
		MOV CAN41,R6
		MOV CAN42,R7
		ORL  WMCON, #EEMEN		 ; enable EEPROM accesses			STORE CANDIDATE 2 VOTES
		ORL WMCON, #EEMWE		 ; enable EEPROM writes
		MOV DPTR, #0006H			 ; address to write
		MOV A, CAN41			 ; data to write
		MOVX @DPTR,A			 ; write EEPROM
		MOV A,WMCON			;Check for eeprom finished or not
		JNB ACC.1,$-2		 ; jump if data compare fails (busy)
		INC DPTR
		MOV A, CAN42			 ; data to write
		MOVX @DPTR,A			 ; write EEPROM
		MOV A,WMCON			;Check for eeprom finished or not
		JNB ACC.1,$-2		 ; jump if data compare fails (busy)
		XRL WMCON, #EEMWE		 ; disable EEPROM writes
		XRL WMCON, #EEMEN		 ; disable EEPROM accesses
		CALL DELAY
		CLR ALRM
		CLR READY_L
		AJMP DOWN_D			

FGF4:	CJNE A,#05H,FGF5
		MOV R6,CAN51
		MOV R7,CAN52
		CALL INCREMENT
		MOV CAN51,R6
		MOV CAN52,R7
		ORL  WMCON, #EEMEN		 ; enable EEPROM accesses			STORE CANDIDATE 2 VOTES
		ORL WMCON, #EEMWE		 ; enable EEPROM writes
		MOV DPTR, #0008H			 ; address to write
		MOV A, CAN51			 ; data to write
		MOVX @DPTR,A			 ; write EEPROM
		MOV A,WMCON			;Check for eeprom finished or not
		JNB ACC.1,$-2		 ; jump if data compare fails (busy)
		INC DPTR
		MOV A, CAN52			 ; data to write
		MOVX @DPTR,A			 ; write EEPROM
		MOV A,WMCON			;Check for eeprom finished or not
		JNB ACC.1,$-2		 ; jump if data compare fails (busy)
		XRL WMCON, #EEMWE		 ; disable EEPROM writes
		XRL WMCON, #EEMEN		 ; disable EEPROM accesses
		CALL DELAY
		CLR ALRM
		CLR READY_L
		AJMP DOWN_D		

FGF5:	CJNE A,#06H,FGF6
		MOV R6,CAN61
		MOV R7,CAN62
		CALL INCREMENT
		MOV CAN61,R6
		MOV CAN62,R7
		ORL  WMCON, #EEMEN		 ; enable EEPROM accesses			STORE CANDIDATE 2 VOTES
		ORL WMCON, #EEMWE		 ; enable EEPROM writes
		MOV DPTR, #000AH			 ; address to write
		MOV A, CAN61			 ; data to write
		MOVX @DPTR,A			 ; write EEPROM
		MOV A,WMCON			;Check for eeprom finished or not
		JNB ACC.1,$-2		 ; jump if data compare fails (busy)
		INC DPTR
		MOV A, CAN62			 ; data to write
		MOVX @DPTR,A			 ; write EEPROM
		MOV A,WMCON			;Check for eeprom finished or not
		JNB ACC.1,$-2		 ; jump if data compare fails (busy)
		XRL WMCON, #EEMWE		 ; disable EEPROM writes
		XRL WMCON, #EEMEN		 ; disable EEPROM accesses
		CALL DELAY
		CLR ALRM
		CLR READY_L
		AJMP DOWN_D		

FGF6:	CJNE A,#07H,FGF7
		MOV R6,CAN71
		MOV R7,CAN72
		CALL INCREMENT
		MOV CAN71,R6
		MOV CAN72,R7
		ORL  WMCON, #EEMEN		 ; enable EEPROM accesses			STORE CANDIDATE 2 VOTES
		ORL WMCON, #EEMWE		 ; enable EEPROM writes
		MOV DPTR, #000CH			 ; address to write
		MOV A, CAN71			 ; data to write
		MOVX @DPTR,A			 ; write EEPROM
		MOV A,WMCON			;Check for eeprom finished or not
		JNB ACC.1,$-2		 ; jump if data compare fails (busy)
		INC DPTR
		MOV A, CAN72			 ; data to write
		MOVX @DPTR,A			 ; write EEPROM
		MOV A,WMCON			;Check for eeprom finished or not
		JNB ACC.1,$-2		 ; jump if data compare fails (busy)
		XRL WMCON, #EEMWE		 ; disable EEPROM writes
		XRL WMCON, #EEMEN		 ; disable EEPROM accesses
		CALL DELAY
		CLR ALRM
		CLR READY_L
		AJMP DOWN_D		

FGF7:	CJNE A,#08H,FGF8
		MOV R6,CAN81
		MOV R7,CAN82
		CALL INCREMENT
		MOV CAN81,R6
		MOV CAN82,R7
		ORL  WMCON, #EEMEN		 ; enable EEPROM accesses			STORE CANDIDATE 2 VOTES
		ORL WMCON, #EEMWE		 ; enable EEPROM writes
		MOV DPTR, #000EH			 ; address to write
		MOV A, CAN81			 ; data to write
		MOVX @DPTR,A			 ; write EEPROM
		MOV A,WMCON			;Check for eeprom finished or not
		JNB ACC.1,$-2		 ; jump if data compare fails (busy)
		INC DPTR
		MOV A, CAN82			 ; data to write
		MOVX @DPTR,A			 ; write EEPROM
		MOV A,WMCON			;Check for eeprom finished or not
		JNB ACC.1,$-2		 ; jump if data compare fails (busy)
		XRL WMCON, #EEMWE		 ; disable EEPROM writes
		XRL WMCON, #EEMEN		 ; disable EEPROM accesses
		CALL DELAY
		CLR ALRM
		CLR READY_L
		AJMP DOWN_D	
	
FGF8:	CJNE A,#09H,FGF9
		MOV R6,CAN91
		MOV R7,CAN92
		CALL INCREMENT
		MOV CAN91,R6
		MOV CAN92,R7
		ORL  WMCON, #EEMEN		 ; enable EEPROM accesses			STORE CANDIDATE 2 VOTES
		ORL WMCON, #EEMWE		 ; enable EEPROM writes
		MOV DPTR, #0010H			 ; address to write
		MOV A, CAN91			 ; data to write
		MOVX @DPTR,A			 ; write EEPROM
		MOV A,WMCON			;Check for eeprom finished or not
		JNB ACC.1,$-2		 ; jump if data compare fails (busy)
		INC DPTR
		MOV A, CAN92			 ; data to write
		MOVX @DPTR,A			 ; write EEPROM
		MOV A,WMCON			;Check for eeprom finished or not
		JNB ACC.1,$-2		 ; jump if data compare fails (busy)
		XRL WMCON, #EEMWE		 ; disable EEPROM writes
		XRL WMCON, #EEMEN		 ; disable EEPROM accesses
		CALL DELAY
		CLR ALRM
		CLR READY_L
		AJMP DOWN_D		

FGF9:	CJNE A,#10H,FGF10
		MOV R6,CANA1
		MOV R7,CANA2
		CALL INCREMENT
		MOV CANA1,R6
		MOV CANA2,R7
		ORL  WMCON, #EEMEN		 ; enable EEPROM accesses			STORE CANDIDATE 2 VOTES
		ORL WMCON, #EEMWE		 ; enable EEPROM writes
		MOV DPTR, #0012H			 ; address to write
		MOV A, CANA1			 ; data to write
		MOVX @DPTR,A			 ; write EEPROM
		MOV A,WMCON			;Check for eeprom finished or not
		JNB ACC.1,$-2		 ; jump if data compare fails (busy)
		INC DPTR
		MOV A, CANA2			 ; data to write
		MOVX @DPTR,A			 ; write EEPROM
		MOV A,WMCON			;Check for eeprom finished or not
		JNB ACC.1,$-2		 ; jump if data compare fails (busy)
		XRL WMCON, #EEMWE		 ; disable EEPROM writes
		XRL WMCON, #EEMEN		 ; disable EEPROM accesses
		CALL DELAY
		CLR ALRM
		CLR READY_L
		AJMP DOWN_D			
		
FGF10:CJNE A,#11H,FGF11
		MOV R6,CANB1
		MOV R7,CANB2
		CALL INCREMENT
		MOV CANB1,R6
		MOV CANB2,R7
		ORL  WMCON, #EEMEN		 ; enable EEPROM accesses			STORE CANDIDATE 2 VOTES
		ORL WMCON, #EEMWE		 ; enable EEPROM writes
		MOV DPTR, #0014H			 ; address to write
		MOV A, CANB1			 ; data to write
		MOVX @DPTR,A			 ; write EEPROM
		MOV A,WMCON			;Check for eeprom finished or not
		JNB ACC.1,$-2		 ; jump if data compare fails (busy)
		INC DPTR
		MOV A, CANB2			 ; data to write
		MOVX @DPTR,A			 ; write EEPROM
		MOV A,WMCON			;Check for eeprom finished or not
		JNB ACC.1,$-2		 ; jump if data compare fails (busy)
		XRL WMCON, #EEMWE		 ; disable EEPROM writes
		XRL WMCON, #EEMEN		 ; disable EEPROM accesses
		CALL DELAY
		CLR ALRM
		CLR READY_L
		AJMP DOWN_D			

FGF11:CJNE A,#12H,FGF12
		MOV R6,CANC1
		MOV R7,CANC2
		CALL INCREMENT
		MOV CANC1,R6
		MOV CANC2,R7
		ORL  WMCON, #EEMEN		 ; enable EEPROM accesses			STORE CANDIDATE 2 VOTES
		ORL WMCON, #EEMWE		 ; enable EEPROM writes
		MOV DPTR, #0016H			 ; address to write
		MOV A, CANC1			 ; data to write
		MOVX @DPTR,A			 ; write EEPROM
		MOV A,WMCON			;Check for eeprom finished or not
		JNB ACC.1,$-2		 ; jump if data compare fails (busy)
		INC DPTR
		MOV A, CANC2			 ; data to write
		MOVX @DPTR,A			 ; write EEPROM
		MOV A,WMCON			;Check for eeprom finished or not
		JNB ACC.1,$-2		 ; jump if data compare fails (busy)
		XRL WMCON, #EEMWE		 ; disable EEPROM writes
		XRL WMCON, #EEMEN		 ; disable EEPROM accesses
		CALL DELAY
		CLR ALRM
		CLR READY_L
		AJMP DOWN_D		
		
FGF12:CJNE A,#13H,FGF13
		MOV R6,CAND1
		MOV R7,CAND2
		CALL INCREMENT
		MOV CAND1,R6
		MOV CAND2,R7
		ORL  WMCON, #EEMEN		 ; enable EEPROM accesses			STORE CANDIDATE 2 VOTES
		ORL WMCON, #EEMWE		 ; enable EEPROM writes
		MOV DPTR, #0018H			 ; address to write
		MOV A, CAND1			 ; data to write
		MOVX @DPTR,A			 ; write EEPROM
		MOV A,WMCON			;Check for eeprom finished or not
		JNB ACC.1,$-2		 ; jump if data compare fails (busy)
		INC DPTR
		MOV A, CAND2			 ; data to write
		MOVX @DPTR,A			 ; write EEPROM
		MOV A,WMCON			;Check for eeprom finished or not
		JNB ACC.1,$-2		 ; jump if data compare fails (busy)
		XRL WMCON, #EEMWE		 ; disable EEPROM writes
		XRL WMCON, #EEMEN		 ; disable EEPROM accesses
		CALL DELAY
		CLR ALRM
		CLR READY_L
		AJMP DOWN_D		
		
FGF13:CJNE A,#14H,FGF14
		MOV R6,CANE1
		MOV R7,CANE2
		CALL INCREMENT
		MOV CANE1,R6
		MOV CANE2,R7
		ORL  WMCON, #EEMEN		 ; enable EEPROM accesses			STORE CANDIDATE 2 VOTES
		ORL WMCON, #EEMWE		 ; enable EEPROM writes
		MOV DPTR, #001AH			 ; address to write
		MOV A, CANE1			 ; data to write
		MOVX @DPTR,A			 ; write EEPROM
		MOV A,WMCON			;Check for eeprom finished or not
		JNB ACC.1,$-2		 ; jump if data compare fails (busy)
		INC DPTR
		MOV A, CANE2			 ; data to write
		MOVX @DPTR,A			 ; write EEPROM
		MOV A,WMCON			;Check for eeprom finished or not
		JNB ACC.1,$-2		 ; jump if data compare fails (busy)
		XRL WMCON, #EEMWE		 ; disable EEPROM writes
		XRL WMCON, #EEMEN		 ; disable EEPROM accesses
		CALL DELAY
		CLR ALRM
		CLR READY_L
		AJMP DOWN_D					

FGF14:CJNE A,#15H,FGF15
		MOV R6,CANF1
		MOV R7,CANF2
		CALL INCREMENT
		MOV CANF1,R6
		MOV CANF2,R7
		ORL  WMCON, #EEMEN		 ; enable EEPROM accesses			STORE CANDIDATE 2 VOTES
		ORL WMCON, #EEMWE		 ; enable EEPROM writes
		MOV DPTR, #001CH			 ; address to write
		MOV A, CANF1			 ; data to write
		MOVX @DPTR,A			 ; write EEPROM
		MOV A,WMCON			;Check for eeprom finished or not
		JNB ACC.1,$-2		 ; jump if data compare fails (busy)
		INC DPTR
		MOV A, CANF2			 ; data to write
		MOVX @DPTR,A			 ; write EEPROM
		MOV A,WMCON			;Check for eeprom finished or not
		JNB ACC.1,$-2		 ; jump if data compare fails (busy)
		XRL WMCON, #EEMWE		 ; disable EEPROM writes
		XRL WMCON, #EEMEN		 ; disable EEPROM accesses
		CALL DELAY
		CLR ALRM
		CLR READY_L
		AJMP DOWN_D	

FGF15:CJNE A,#16H,DOWN_D
		MOV R6,CANG1
		MOV R7,CANG2
		CALL INCREMENT
		MOV CANG1,R6
		MOV CANG2,R7
		ORL  WMCON, #EEMEN		 ; enable EEPROM accesses			STORE CANDIDATE 2 VOTES
		ORL WMCON, #EEMWE		 ; enable EEPROM writes
		MOV DPTR, #001EH			 ; address to write
		MOV A, CANG1			 ; data to write
		MOVX @DPTR,A			 ; write EEPROM
		MOV A,WMCON			;Check for eeprom finished or not
		JNB ACC.1,$-2		 ; jump if data compare fails (busy)
		INC DPTR
		MOV A, CANG2			 ; data to write
		MOVX @DPTR,A			 ; write EEPROM
		MOV A,WMCON			;Check for eeprom finished or not
		JNB ACC.1,$-2		 ; jump if data compare fails (busy)
		XRL WMCON, #EEMWE		 ; disable EEPROM writes
		XRL WMCON, #EEMEN		 ; disable EEPROM accesses
		CALL DELAY
		CLR ALRM
		CLR READY_L
;***********************************************************									
DOWN_D:
		SETB COUNTING
		SETB CLEAR
		JNB COUNTING,DISP_COUNT
		JNB CLEAR,CLEAR_MEM
		
		
;***********************************************************		
CLEAR_MEM:	
		JNB CLEAR,$
		ORL  WMCON, #EEMEN		 ; enable EEPROM accesses			STORE CANDIDATE 2 VOTES
		ORL WMCON, #EEMWE		 ; enable EEPROM writes
		MOV DPTR, #0000H			 ; address to write
REPP4:MOV A, 0FFH			 ; data to write
		MOVX @DPTR,A			 ; write EEPROM
		MOV A,WMCON			;Check for eeprom finished or not
		JNB ACC.1,$-2		 ; jump if data compare fails (busy)
		INC DPTR
		MOV A,DPL
		CJNE A,#30H,REPP4
		XRL WMCON, #EEMWE		 ; disable EEPROM writes
		XRL WMCON, #EEMEN		 ; disable EEPROM accesses
		AJMP $
;***********************************************************		
DISP_COUNT:		
		JNB COUNTING,$
		MOV VALUE_1,#15H
		MOV VALUE_2,#15H
		MOV VALUE_3,#15H
		MOV VALUE_4,#01H
		CALL DELAY
		CALL DELAY
		MOV DPTR,#0000H
		ORL  WMCON, #EEMEN		 ; enable EEPROM accesses
		MOVX A,@DPTR
		MOV R2,A
		INC DPTR
		MOVX A,@DPTR
		MOV R1,A
		CALL HEX2BCD		
		CALL DELAYS
		
		MOV VALUE_1,#15H
		MOV VALUE_2,#15H
		MOV VALUE_3,#15H
		MOV VALUE_4,#02H
		CALL DELAY
		CALL DELAY
		MOV DPTR,#0002H
		ORL  WMCON, #EEMEN		 ; enable EEPROM accesses
		MOVX A,@DPTR
		MOV R2,A
		INC DPTR
		MOVX A,@DPTR
		MOV R1,A
		CALL HEX2BCD		
		CALL DELAYS
		
		MOV VALUE_1,#15H
		MOV VALUE_2,#15H
		MOV VALUE_3,#15H
		MOV VALUE_4,#03H
		CALL DELAY
		CALL DELAY
		MOV DPTR,#0004H
		ORL  WMCON, #EEMEN		 ; enable EEPROM accesses
		MOVX A,@DPTR
		MOV R2,A
		INC DPTR
		MOVX A,@DPTR
		MOV R1,A
		CALL HEX2BCD		
		CALL DELAYS
		
		MOV VALUE_1,#15H
		MOV VALUE_2,#15H
		MOV VALUE_3,#15H
		MOV VALUE_4,#04H
		CALL DELAY
		CALL DELAY
		MOV DPTR,#0006H
		ORL  WMCON, #EEMEN		 ; enable EEPROM accesses
		MOVX A,@DPTR
		MOV R2,A
		INC DPTR
		MOVX A,@DPTR
		MOV R1,A
		CALL HEX2BCD		
		CALL DELAYS
		
		
		MOV VALUE_1,#15H
		MOV VALUE_2,#15H
		MOV VALUE_3,#15H
		MOV VALUE_4,#05H
		CALL DELAY
		CALL DELAY
		MOV DPTR,#0008H
		ORL  WMCON, #EEMEN		 ; enable EEPROM accesses
		MOVX A,@DPTR
		MOV R2,A
		INC DPTR
		MOVX A,@DPTR
		MOV R1,A
		CALL HEX2BCD		
		CALL DELAYS
		
		MOV VALUE_1,#15H
		MOV VALUE_2,#15H
		MOV VALUE_3,#15H
		MOV VALUE_4,#06H
		CALL DELAY
		CALL DELAY
		MOV DPTR,#000AH
		ORL  WMCON, #EEMEN		 ; enable EEPROM accesses
		MOVX A,@DPTR
		MOV R2,A
		INC DPTR
		MOVX A,@DPTR
		MOV R1,A
		CALL HEX2BCD		
		CALL DELAYS
		
		MOV VALUE_1,#15H
		MOV VALUE_2,#15H
		MOV VALUE_3,#15H
		MOV VALUE_4,#07H
		CALL DELAY
		CALL DELAY
		MOV DPTR,#000CH
		ORL  WMCON, #EEMEN		 ; enable EEPROM accesses
		MOVX A,@DPTR
		MOV R2,A
		INC DPTR
		MOVX A,@DPTR
		MOV R1,A
		CALL HEX2BCD		
		CALL DELAYS
		
		MOV VALUE_1,#15H
		MOV VALUE_2,#15H
		MOV VALUE_3,#15H
		MOV VALUE_4,#08H
		CALL DELAY
		CALL DELAY
		MOV DPTR,#000EH
		ORL  WMCON, #EEMEN		 ; enable EEPROM accesses
		MOVX A,@DPTR
		MOV R2,A
		INC DPTR
		MOVX A,@DPTR
		MOV R1,A
		CALL HEX2BCD		
		CALL DELAYS
		
		MOV VALUE_1,#15H
		MOV VALUE_2,#15H
		MOV VALUE_3,#15H
		MOV VALUE_4,#09H
		CALL DELAY
		CALL DELAY
		MOV DPTR,#0010H
		ORL  WMCON, #EEMEN		 ; enable EEPROM accesses
		MOVX A,@DPTR
		MOV R2,A
		INC DPTR
		MOVX A,@DPTR
		MOV R1,A
		CALL HEX2BCD		
		CALL DELAYS

		MOV VALUE_1,#15H
		MOV VALUE_2,#15H
		MOV VALUE_3,#10H
		MOV VALUE_4,#00H
		CALL DELAY
		CALL DELAY
		MOV DPTR,#0012H
		ORL  WMCON, #EEMEN		 ; enable EEPROM accesses
		MOVX A,@DPTR
		MOV R2,A
		INC DPTR
		MOVX A,@DPTR
		MOV R1,A
		CALL HEX2BCD		
		CALL DELAYS

		MOV VALUE_1,#15H
		MOV VALUE_2,#15H
		MOV VALUE_3,#10H
		MOV VALUE_4,#01H
		CALL DELAY
		CALL DELAY
		MOV DPTR,#0014H
		ORL  WMCON, #EEMEN		 ; enable EEPROM accesses
		MOVX A,@DPTR
		MOV R2,A
		INC DPTR
		MOVX A,@DPTR
		MOV R1,A
		CALL HEX2BCD		
		CALL DELAYS

		MOV VALUE_1,#15H
		MOV VALUE_2,#15H
		MOV VALUE_3,#10H
		MOV VALUE_4,#02H
		CALL DELAY
		CALL DELAY
		MOV DPTR,#0016H
		ORL  WMCON, #EEMEN		 ; enable EEPROM accesses
		MOVX A,@DPTR
		MOV R2,A
		INC DPTR
		MOVX A,@DPTR
		MOV R1,A
		CALL HEX2BCD		
		CALL DELAYS

		MOV VALUE_1,#15H
		MOV VALUE_2,#15H
		MOV VALUE_3,#10H
		MOV VALUE_4,#03H
		CALL DELAY
		CALL DELAY
		MOV DPTR,#0018H
		ORL  WMCON, #EEMEN		 ; enable EEPROM accesses
		MOVX A,@DPTR
		MOV R2,A
		INC DPTR
		MOVX A,@DPTR
		MOV R1,A
		CALL HEX2BCD		
		CALL DELAYS

		MOV VALUE_1,#15H
		MOV VALUE_2,#15H
		MOV VALUE_3,#10H
		MOV VALUE_4,#04H
		CALL DELAY
		CALL DELAY
		MOV DPTR,#001AH
		ORL  WMCON, #EEMEN		 ; enable EEPROM accesses
		MOVX A,@DPTR
		MOV R2,A
		INC DPTR
		MOVX A,@DPTR
		MOV R1,A
		CALL HEX2BCD		
		CALL DELAYS
		
		MOV VALUE_1,#15H
		MOV VALUE_2,#15H
		MOV VALUE_3,#10H
		MOV VALUE_4,#05H
		CALL DELAY
		CALL DELAY
		MOV DPTR,#001CH
		ORL  WMCON, #EEMEN		 ; enable EEPROM accesses
		MOVX A,@DPTR
		MOV R2,A
		INC DPTR
		MOVX A,@DPTR
		MOV R1,A
		CALL HEX2BCD		
		CALL DELAYS
		
		MOV VALUE_1,#15H
		MOV VALUE_2,#15H
		MOV VALUE_3,#10H
		MOV VALUE_4,#06H
		CALL DELAY
		CALL DELAY
		MOV DPTR,#001EH
		ORL  WMCON, #EEMEN		 ; enable EEPROM accesses
		MOVX A,@DPTR
		MOV R2,A
		INC DPTR
		MOVX A,@DPTR
		MOV R1,A
		CALL HEX2BCD		
		CALL DELAYS
		
		XRL WMCON, #EEMEN	 ; disable EEPROM accesses
		
		SETB COUNTING
		JB COUNTING,$
		AJMP DISP_COUNT
		

;***********************************************************
INCREMENT:	
		MOV A,R6
		CJNE A,#0FFH,VVBW
		MOV R6,#00H
		INC R7
VVBW:	INC R6
		RET
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
; 	7 SEGMENT DISPLAY ROUTINE
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
DISP:
	MOV R2,SPEED
	CJNE R2,#00H,AAS1
	CLR DIS_A
	CLR DIS_B
	CLR DIS_C
	CLR DIS_D
	CLR DIS_E
	CLR DIS_F
	SETB DIS_G
	RET
AAS1:	CJNE R2,#01H,AS2
	CLR DIS_B
	CLR DIS_C
	SETB DIS_A
	SETB DIS_D
	SETB DIS_E
	SETB DIS_F
	SETB DIS_G
	RET
AS2:	CJNE R2,#02H,AS3
	CLR DIS_A
	CLR DIS_B
	CLR DIS_D
	CLR DIS_E
	CLR DIS_G
	SETB DIS_C
	SETB DIS_F
	RET
AS3:	CJNE R2,#03H,AS4
	CLR DIS_A    
	CLR DIS_B
	CLR DIS_C
	CLR DIS_D
	CLR DIS_G
	SETB DIS_E
	SETB DIS_F
	RET
AS4:	CJNE R2,#04H,AS5
	CLR DIS_B
	CLR DIS_C
	CLR DIS_F
	CLR DIS_G
	SETB DIS_A
	SETB DIS_D
	SETB DIS_E
	RET
AS5:	CJNE R2,#05H,AS6
	CLR DIS_A
	CLR DIS_C
	CLR DIS_D
	CLR DIS_F
	CLR DIS_G
	SETB  DIS_B
	SETB DIS_E
	RET
AS6:	CJNE R2,#06H,AS7
	CLR DIS_A
	CLR DIS_C
	CLR DIS_D
	CLR DIS_E
	CLR DIS_F
	CLR DIS_G
	SETB DIS_B
	RET
AS7:	CJNE R2,#07H,AS8
	CLR DIS_A
	CLR DIS_B
	CLR DIS_C
	SETB DIS_D
	SETB DIS_E
	SETB DIS_F
	SETB DIS_G
	RET
AS8:	CJNE R2,#08H,AS9
	CLR DIS_A
	CLR DIS_B
	CLR DIS_C
	CLR DIS_D
	CLR DIS_E
	CLR DIS_F
	CLR DIS_G
	RET
AS9:	CJNE R2,#09H,AS10
	CLR DIS_A
	CLR DIS_B
	CLR DIS_C
	CLR DIS_D
	CLR DIS_F
	CLR DIS_G
	SETB DIS_E
	RET
AS10:	CJNE R2,#15H,AS11		;symbol for -
	SETB DIS_A
	SETB DIS_B
	SETB DIS_C
	SETB DIS_D
	SETB DIS_E
	SETB DIS_F
	CLR DIS_G
	RET
AS11:	CJNE R2,#16H,AS12		;switch off all disp
	SETB DIS_A
	SETB DIS_B
	SETB DIS_C
	SETB DIS_D
	SETB DIS_E
	SETB DIS_F
	SETB DIS_G
	RET
AS12:	MOV SPEED,#00H
	JMP DISP
;**********************************************************	
;		INTRRUPT ROUTINE TO REFRESH THE DISPLAY
;**********************************************************	
REFRESH:
	PUSH   PSW           ; save current registerset
        MOV    PSW,#RB1
        PUSH   ACC
	INC COUNT
	MOV R4,COUNT
QA1:	CJNE R4,#01H,QA2
	MOV SPEED,VALUE_1
	SETB DIS1
	CLR DIS2
	CLR DIS3
	CLR DIS4
	CALL DISP 
	AJMP DOWN   
QA2:	CJNE R4,#02H,QA3
	MOV SPEED,VALUE_2
	CLR DIS1
	SETB DIS2
	CLR DIS3
	CLR DIS4
	CALL DISP 
	AJMP DOWN
QA3:	CJNE R4,#03H,QA4
	MOV SPEED,VALUE_3
	CLR DIS1
	CLR DIS2
	SETB DIS3
	CLR DIS4
	CALL DISP 
	AJMP DOWN
QA4:	CJNE R4,#04H,QA5
	MOV SPEED,VALUE_4
	CLR DIS1
	CLR DIS2
	CLR DIS3
	SETB DIS4
	CALL DISP 
	AJMP DOWN
QA5:	MOV COUNT,#01H
	MOV R4,COUNT
	AJMP QA1
DOWN:	MOV TL0,#0FFH
	MOV TH0,#0F0H
	POP    ACC
        POP    PSW
	RETI
;**********************************************************	
		
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
DELAY:
		MOV R1,#0FFH
RE1:	MOV R2,#0FFH
RE:	NOP
		DJNZ R2,RE
		DJNZ R1,RE1
		RET
;**********************************************************
DELAYS:
		MOV R3,#03H
EDE2:	MOV R1,#0FFH
RAE1:	MOV R2,#0FFH
RAE:	NOP
		DJNZ R2,RAE
		DJNZ R1,RAE1
		DJNZ R3,EDE2
		RET
;**********************************************************
DELAY1:
		MOV R1,#9FH
REA1:	MOV R2,#0FFH
REA:	NOP
		DJNZ R2,REA
		DJNZ R1,REA1
		RET
;**********************************************************
RESET_VOTE:
		MOV A,#00H
		MOV CAN11,A
		MOV CAN12,A
		MOV CAN21,A
		MOV CAN22,A
		MOV CAN31,A
		MOV CAN32,A
		MOV CAN41,A
		MOV CAN42,A
		MOV CAN51,A
		MOV CAN52,A
		MOV CAN61,A
		MOV CAN62,A
		MOV CAN71,A
		MOV CAN72,A
		MOV CAN81,A
		MOV CAN82,A
		MOV CAN91,A
		MOV CAN92,A
		MOV CANA1,A
		MOV CANA2,A
		MOV CANB1,A
		MOV CANB2,A
		MOV CANC1,A
		MOV CANC2,A
		MOV CAND1,A
		MOV CAND2,A
		MOV CANE1,A
		MOV CANE2,A
		MOV CANF1,A
		MOV CANF2,A
		RET
;((((((((((((((((((((((((((((((((
DEALAY:
	MOV R1,#50
REPP2:	NOP
	DJNZ R1,REPP2
	RET
;((((((((((((((((((((((((((((((((
Hex2BCD:
        MOV R3,#00D
        MOV R4,#00D
        MOV R5,#00D
        MOV R6,#00D
        MOV R7,#00D
        CALL H2B
        AJMP $
        
H2B:		MOV B,#10D
        MOV A,R2
        DIV AB
        MOV   R3,B              ;   
        MOV   B,#10             ; R7,R6,R5,R4,R3
        DIV   AB
        MOV   R4,B
        MOV   R5,A
        CJNE R1,#0H,HIGH_BYTE   ; CHECK FOR HIGH BYTE
        SJMP ENDD
 
HIGH_BYTE:
MOV   A,#6
        ADD   A,R3
MOV   B,#10
DIV   AB
        MOV   R3,B
ADD   A,#5
        ADD   A,R4
MOV   B,#10
DIV   AB
        MOV   R4,B
ADD   A,#2
        ADD   A,R5
MOV   B,#10
DIV   AB
        MOV   R5,B
        CJNE R6,#00D,ADD_IT
        SJMP CONTINUE
ADD_IT:
        ADD A,R6
CONTINUE:
        MOV R6,A
        DJNZ R1,HIGH_BYTE
        MOV B, #10D
        MOV A,R6
        DIV AB
        MOV R6,B
        MOV R7,A
ENDD:   MOV VALUE_1,R6
		MOV VALUE_2,R5
		MOV VALUE_3,R4
		MOV VALUE_4,R3
			RET 

END
